/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atfin.plx

\***************************************************************************/

#if !defined(ATFIN_PLX)
#define ATFIN_PLX
#define ll3atfin_name "ATFIN"
/* C-Interface arguments defines */
#define LPI_ATFIN_CTERM_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 interest,\
 lfloat10 fv,\
 lfloat10 pv,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_DDB_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lfloat10 period,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_FV_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 payment,\
 lfloat10 interest,\
 lfloat10 term,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_IRR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 floatValue,\
 LpiRangeType theRange,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_NPV_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 floatValue,\
 LpiRangeType theRange,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_PMT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 principal,\
 lfloat10 interest,\
 lfloat10 term,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_PV_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 payment,\
 lfloat10 interest,\
 lfloat10 term,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_RATE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 fv,\
 lfloat10 pv,\
 lfloat10 term,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_SLN_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_SYD_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lfloat10 period,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_TERM_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 payment,\
 lfloat10 interest,\
 lfloat10 fv,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_VDB1_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lfloat10 start,\
 lfloat10 end,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_VDB2_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lfloat10 start,\
 lfloat10 end,\
 lfloat10 depr,\
 lptr(lfloat10) outarg)
#define LPI_ATFIN_VDB3_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 cost,\
 lfloat10 salvage,\
 lfloat10 life,\
 lfloat10 start,\
 lfloat10 end,\
 lfloat10 depr,\
 lushort vdbtype,\
 lptr(lfloat10) outarg)
/* C-interface function prototypes */
lexppro (lsshort, lpi_atfin_cterm, LPI_ATFIN_CTERM_ARGS);
lexppro (lsshort, lpi_atfin_ddb, LPI_ATFIN_DDB_ARGS);
lexppro (lsshort, lpi_atfin_fv, LPI_ATFIN_FV_ARGS);
lexppro (lsshort, lpi_atfin_irr, LPI_ATFIN_IRR_ARGS);
lexppro (lsshort, lpi_atfin_npv, LPI_ATFIN_NPV_ARGS);
lexppro (lsshort, lpi_atfin_pmt, LPI_ATFIN_PMT_ARGS);
lexppro (lsshort, lpi_atfin_pv, LPI_ATFIN_PV_ARGS);
lexppro (lsshort, lpi_atfin_rate, LPI_ATFIN_RATE_ARGS);
lexppro (lsshort, lpi_atfin_sln, LPI_ATFIN_SLN_ARGS);
lexppro (lsshort, lpi_atfin_syd, LPI_ATFIN_SYD_ARGS);
lexppro (lsshort, lpi_atfin_term, LPI_ATFIN_TERM_ARGS);
lexppro (lsshort, lpi_atfin_vdb1, LPI_ATFIN_VDB1_ARGS);
lexppro (lsshort, lpi_atfin_vdb2, LPI_ATFIN_VDB2_ARGS);
lexppro (lsshort, lpi_atfin_vdb3, LPI_ATFIN_VDB3_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_atfin_cterm, LPI_ATFIN_CTERM_ARGS);
    lexpptr (lsshort, lpi_atfin_ddb, LPI_ATFIN_DDB_ARGS);
    lexpptr (lsshort, lpi_atfin_fv, LPI_ATFIN_FV_ARGS);
    lexpptr (lsshort, lpi_atfin_irr, LPI_ATFIN_IRR_ARGS);
    lexpptr (lsshort, lpi_atfin_npv, LPI_ATFIN_NPV_ARGS);
    lexpptr (lsshort, lpi_atfin_pmt, LPI_ATFIN_PMT_ARGS);
    lexpptr (lsshort, lpi_atfin_pv, LPI_ATFIN_PV_ARGS);
    lexpptr (lsshort, lpi_atfin_rate, LPI_ATFIN_RATE_ARGS);
    lexpptr (lsshort, lpi_atfin_sln, LPI_ATFIN_SLN_ARGS);
    lexpptr (lsshort, lpi_atfin_syd, LPI_ATFIN_SYD_ARGS);
    lexpptr (lsshort, lpi_atfin_term, LPI_ATFIN_TERM_ARGS);
    lexpptr (lsshort, lpi_atfin_vdb1, LPI_ATFIN_VDB1_ARGS);
    lexpptr (lsshort, lpi_atfin_vdb2, LPI_ATFIN_VDB2_ARGS);
    lexpptr (lsshort, lpi_atfin_vdb3, LPI_ATFIN_VDB3_ARGS);
}atfin_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_ATFIN_GLOBAL_REF  LPI_CALL_DATA->atfin_global
#define LPI_ATFIN_TABLE_REF   LPI_CALL_DATA->atfin_table
#else
#define LPI_ATFIN_GLOBAL_REF  lts_atfin_global
#define LPI_ATFIN_TABLE_REF   lts_atfin_table
#endif
#define LpiAtfinCTerm(arg1, arg2, arg3, arg4)                     \
            (*LPI_ATFIN_TABLE_REF->lpi_atfin_cterm)        \
            (LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinDDB(arg1, arg2, arg3, arg4, arg5) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_ddb)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4, arg5)
#define LpiAtfinFV(arg1, arg2, arg3, arg4) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_fv)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinIRR(arg1, arg2, arg3) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_irr)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtfinNPV(arg1, arg2, arg3) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_npv)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtfinPmt(arg1, arg2, arg3, arg4)                         \
            (*LPI_ATFIN_TABLE_REF->lpi_atfin_pmt)            \
            (LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinPV(arg1, arg2, arg3, arg4) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_pv)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinRate(arg1, arg2, arg3, arg4) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_rate)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinSLn(arg1, arg2, arg3, arg4) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_sln)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinSYD(arg1, arg2, arg3, arg4, arg5) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_syd)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4, arg5)
#define LpiAtfinTerm(arg1, arg2, arg3, arg4) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_term)(LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtfinVDB(arg1, arg2, arg3, arg4, arg5, arg6) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_vdb1)  (LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4, arg5, arg6)
#define LpiAtfinVDBDepr(arg1, arg2, arg3, arg4, arg5, arg6, arg7) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_vdb2)  (LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#define LpiAtfinVDBDeprType(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) \
    (*LPI_ATFIN_TABLE_REF->lpi_atfin_vdb3)  (LPI_ATFIN_GLOBAL_REF, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
#endif
#endif
