/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  file.plx

\***************************************************************************/

#if !defined(FILE_PLX)
#define FILE_PLX
#define ll3file_name    "FILE"
/* Argument defines for C-callable functions
 */
#define LPI_FILE_DEST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiFileType) data_mp)
#define LPI_FILE_CONST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiFileType) adt_mp,\
 lmhdl(lmbcs) finspec)
#define LPI_FILE_CONST_ACCESS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiFileType) adt_mp,\
 lmhdl(lmbcs) access_str,\
 lushort access_method)
#define LPI_FILE_GET_FULLNAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmhdl(lmbcs)) fspec)
#define LPI_FILE_SET_FULLNAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) fspec)
#define LPI_FILE_GET_PATH_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmhdl(lmbcs)) path)
#define LPI_FILE_SET_PATH_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) path_mp)
#define LPI_FILE_GET_NAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmhdl(lmbcs)) name)
#define LPI_FILE_GET_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmbcs) ext)
#define LPI_FILE_SET_NAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) name_mp,\
 lmhdl(lmbcs) ext_mp)
#define LPI_FILE_GET_OPENED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lbool) opnflg)
#define LPI_FILE_GET_EXISTS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lbool) retcode)
#define LPI_FILE_SET_POSITION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lulong offset,\
 lushort org)
#define LPI_FILE_GET_POSITION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lulong) offsetp)
#define LPI_FILE_GET_LASTWRITE_STR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmhdl(lmbcs)) dstrp,\
 lptr(lmhdl(lmbcs)) tstrp)
#define LPI_FILE_GET_LASTWRITE_NUM_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lfloat10) tstamp)
#define LPI_FILE_GET_SIZE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lulong) fsizep)
#define LPI_FILE_OPEN_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lushort amode)
#define LPI_FILE_CLOSE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp)
#define LPI_FILE_DELETE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp)
#define LPI_FILE_READ_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) lmbcs_mptr,\
 lushort rd_max)
#define LPI_FILE_READ_BYTES_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) lmbcs_mptr,\
 lushort cnt)
#define LPI_FILE_READ_BINARY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) buffer,\
 lushort cnt,\
 lptr(lushort) bytesread)
#define LPI_FILE_RENAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType oldadt_mp,\
 lmhdl(lmbcs) newname_mp)
#define LPI_FILE_WRITE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) buf_mp)
#define LPI_FILE_WRITE_BYTES_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) buf_mp,\
 lushort cnt)
#define LPI_FILE_WRITE_BINARY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lmhdl(lmbcs) buf_mp,\
 lushort cnt,\
 lptr(lushort) byteswritten)
#define LPI_FILE_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiFileType adt_mp,\
 lptr(lmhdl(lmbcs)) namestr)
/* typedefs for c-callable functions
 */
lexppro (lsshort, lpi_file_dest, LPI_FILE_DEST_ARGS);
lexppro (lsshort, lpi_file_const, LPI_FILE_CONST_ARGS);
lexppro (lsshort, lpi_file_const_access, LPI_FILE_CONST_ACCESS_ARGS);
lexppro (lsshort, lpi_file_get_fullname, LPI_FILE_GET_FULLNAME_ARGS);
lexppro (lsshort, lpi_file_set_fullname, LPI_FILE_SET_FULLNAME_ARGS);
lexppro (lsshort, lpi_file_get_path, LPI_FILE_GET_PATH_ARGS);
lexppro (lsshort, lpi_file_set_path, LPI_FILE_SET_PATH_ARGS);
lexppro (lsshort, lpi_file_get_name, LPI_FILE_GET_NAME_ARGS);
lexppro (lsshort, lpi_file_get_extension, LPI_FILE_GET_EXTENSION_ARGS);
lexppro (lsshort, lpi_file_set_name, LPI_FILE_SET_NAME_ARGS);
lexppro (lsshort, lpi_file_get_opened, LPI_FILE_GET_OPENED_ARGS);
lexppro (lsshort, lpi_file_get_exists, LPI_FILE_GET_EXISTS_ARGS);
lexppro (lsshort, lpi_file_set_position, LPI_FILE_SET_POSITION_ARGS);
lexppro (lsshort, lpi_file_get_position, LPI_FILE_GET_POSITION_ARGS);
lexppro (lsshort, lpi_file_get_lastwrite_str, LPI_FILE_GET_LASTWRITE_STR_ARGS);
lexppro (lsshort, lpi_file_get_lastwrite_num, LPI_FILE_GET_LASTWRITE_NUM_ARGS);
lexppro (lsshort, lpi_file_get_size, LPI_FILE_GET_SIZE_ARGS);
lexppro (lsshort, lpi_file_open, LPI_FILE_OPEN_ARGS);
lexppro (lsshort, lpi_file_close, LPI_FILE_CLOSE_ARGS);
lexppro (lsshort, lpi_file_delete, LPI_FILE_DELETE_ARGS);
lexppro (lsshort, lpi_file_read, LPI_FILE_READ_ARGS);
lexppro (lsshort, lpi_file_read_bytes, LPI_FILE_READ_BYTES_ARGS);
lexppro (lsshort, lpi_file_read_binary, LPI_FILE_READ_BINARY_ARGS);
lexppro (lsshort, lpi_file_rename, LPI_FILE_RENAME_ARGS);
lexppro (lsshort, lpi_file_write, LPI_FILE_WRITE_ARGS);
lexppro (lsshort, lpi_file_write_bytes, LPI_FILE_WRITE_BYTES_ARGS);
lexppro (lsshort, lpi_file_write_binary, LPI_FILE_WRITE_BINARY_ARGS);
lexppro (lsshort, lpi_file_string, LPI_FILE_STRING_ARGS);
/* Pointers to C callable functions */
typedef struct
        {
  lexpptr (lsshort, lpi_file_const, LPI_FILE_CONST_ARGS);
  lexpptr (lsshort, lpi_file_const_access, LPI_FILE_CONST_ACCESS_ARGS);
  lexpptr (lsshort, lpi_file_dest, LPI_FILE_DEST_ARGS);
  lexpptr (lsshort, lpi_file_get_fullname, LPI_FILE_GET_FULLNAME_ARGS);
  lexpptr (lsshort, lpi_file_set_fullname, LPI_FILE_SET_FULLNAME_ARGS);
  lexpptr (lsshort, lpi_file_get_path, LPI_FILE_GET_PATH_ARGS);
  lexpptr (lsshort, lpi_file_set_path, LPI_FILE_SET_PATH_ARGS);
  lexpptr (lsshort, lpi_file_get_name, LPI_FILE_GET_NAME_ARGS);
  lexpptr (lsshort, lpi_file_get_extension, LPI_FILE_GET_EXTENSION_ARGS);
  lexpptr (lsshort, lpi_file_set_name, LPI_FILE_SET_NAME_ARGS);
  lexpptr (lsshort, lpi_file_get_opened, LPI_FILE_GET_OPENED_ARGS);
  lexpptr (lsshort, lpi_file_get_exists, LPI_FILE_GET_EXISTS_ARGS);
  lexpptr (lsshort, lpi_file_set_position, LPI_FILE_SET_POSITION_ARGS);
  lexpptr (lsshort, lpi_file_get_position, LPI_FILE_GET_POSITION_ARGS);
  lexpptr (lsshort, lpi_file_get_lastwrite_str, LPI_FILE_GET_LASTWRITE_STR_ARGS);
  lexpptr (lsshort, lpi_file_get_lastwrite_num, LPI_FILE_GET_LASTWRITE_NUM_ARGS);
  lexpptr (lsshort, lpi_file_get_size, LPI_FILE_GET_SIZE_ARGS);
  lexpptr (lsshort, lpi_file_open, LPI_FILE_OPEN_ARGS);
  lexpptr (lsshort, lpi_file_close, LPI_FILE_CLOSE_ARGS);
  lexpptr (lsshort, lpi_file_delete, LPI_FILE_DELETE_ARGS);
  lexpptr (lsshort, lpi_file_read, LPI_FILE_READ_ARGS);
  lexpptr (lsshort, lpi_file_read_bytes, LPI_FILE_READ_BYTES_ARGS);
  lexpptr (lsshort, lpi_file_read_binary, LPI_FILE_READ_BINARY_ARGS);
  lexpptr (lsshort, lpi_file_rename, LPI_FILE_RENAME_ARGS);
  lexpptr (lsshort, lpi_file_write, LPI_FILE_WRITE_ARGS);
  lexpptr (lsshort, lpi_file_write_bytes, LPI_FILE_WRITE_BYTES_ARGS);
  lexpptr (lsshort, lpi_file_write_binary, LPI_FILE_WRITE_BINARY_ARGS);
  lexpptr (lsshort, lpi_file_string, LPI_FILE_STRING_ARGS);
} file_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
/* string buffer-length constants (PC only) */
#if (LPI_ENVIRONMENT == LPI_123R3PC)
#define LPI_FILE_FILEEXT_BUFLEN 7
#endif
#if defined(NOGLOBALDATA)
#define LPI_FILE_GLOBAL_REF  LPI_CALL_DATA->file_global
#define LPI_FILE_TABLE_REF   LPI_CALL_DATA->file_table
#else
/* global data IS supported -- perform calls through static struct */
#define LPI_FILE_GLOBAL_REF  lts_file_global
#define LPI_FILE_TABLE_REF   lts_file_table
#endif
#define LpiFileConstruct(xADTdata, arg1)                    \
                (*LPI_FILE_TABLE_REF->lpi_file_const)       \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileConstructAccess(xADTdata, arg1, arg2)        \
                (*LPI_FILE_TABLE_REF->lpi_file_const_access)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileDestroy(xADTdata)                            \
                (*LPI_FILE_TABLE_REF->lpi_file_dest)        \
                (LPI_FILE_GLOBAL_REF, xADTdata)
#define LpiFileGetFullName(xADTdata, arg1)                  \
                (*LPI_FILE_TABLE_REF->lpi_file_get_fullname)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileSetFullName(xADTdata, arg1)                  \
                (*LPI_FILE_TABLE_REF->lpi_file_set_fullname)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetPath(xADTdata, arg1)                      \
                (*LPI_FILE_TABLE_REF->lpi_file_get_path)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileSetPath(xADTdata, arg1)                      \
                (*LPI_FILE_TABLE_REF->lpi_file_set_path)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetName(xADTdata, arg1)                      \
                (*LPI_FILE_TABLE_REF->lpi_file_get_name)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetExtension(xADTdata, arg1)                 \
                (*LPI_FILE_TABLE_REF->lpi_file_get_extension) \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileSetName(xADTdata, arg1)                      \
                (*LPI_FILE_TABLE_REF->lpi_file_set_name)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, LNULL)
#define LpiFileSetExtension(xADTdata, arg1)                 \
                (*LPI_FILE_TABLE_REF->lpi_file_set_name)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, LNULL, arg1)
#define LpiFileGetOpened(xADTdata, arg1)                    \
                (*LPI_FILE_TABLE_REF->lpi_file_get_opened)  \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetExists(xADTdata, arg1)                    \
                (*LPI_FILE_TABLE_REF->lpi_file_get_exists)  \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileSetPosition(xADTdata, arg1)                  \
                (*LPI_FILE_TABLE_REF->lpi_file_set_position)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, LPI_T_ORIGIN_START)
#define LpiFileSetPositionOrigin(xADTdata, arg1, arg2)      \
                (*LPI_FILE_TABLE_REF->lpi_file_set_position)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileGetPosition(xADTdata, arg1)                  \
                (*LPI_FILE_TABLE_REF->lpi_file_get_position)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetLastWriteString(xADTdata, arg1, arg2)     \
                (*LPI_FILE_TABLE_REF->lpi_file_get_lastwrite_str) \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileGetLastWriteFloat(xADTdata, arg1)            \
                (*LPI_FILE_TABLE_REF->lpi_file_get_lastwrite_num) \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileGetSize(xADTdata, arg1)                      \
                (*LPI_FILE_TABLE_REF->lpi_file_get_size)    \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileOpen(xADTdata, arg1)                         \
                (*LPI_FILE_TABLE_REF->lpi_file_open)        \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileClose(xADTdata)                              \
                (*LPI_FILE_TABLE_REF->lpi_file_close)       \
                (LPI_FILE_GLOBAL_REF, xADTdata)
#define LpiFileDelete(xADTdata)                             \
                (*LPI_FILE_TABLE_REF->lpi_file_delete)      \
                (LPI_FILE_GLOBAL_REF, xADTdata)
#define LpiFileRead(xADTdata, arg1, arg2)                   \
                (*LPI_FILE_TABLE_REF->lpi_file_read)        \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileReadBytes(xADTdata, arg1, arg2)              \
                (*LPI_FILE_TABLE_REF->lpi_file_read_bytes)  \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileReadBinary(xADTdata, arg1, arg2, arg3)       \
                (*LPI_FILE_TABLE_REF->lpi_file_read_binary) \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiFileRename(xADTdata, arg1)                       \
                (*LPI_FILE_TABLE_REF->lpi_file_rename)      \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileWrite(xADTdata, arg1)                        \
                (*LPI_FILE_TABLE_REF->lpi_file_write)       \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#define LpiFileWriteBytes(xADTdata, arg1, arg2)             \
                (*LPI_FILE_TABLE_REF->lpi_file_write_bytes) \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiFileWriteBinary(xADTdata, arg1, arg2, arg3)      \
                (*LPI_FILE_TABLE_REF->lpi_file_write_binary)\
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiFileString(xADTdata, arg1)                       \
                (*LPI_FILE_TABLE_REF->lpi_file_string)      \
                (LPI_FILE_GLOBAL_REF, xADTdata, arg1)
#endif      /* all the exported macros */
#endif                  /* End of file.plx */
