/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  macro.plx

\***************************************************************************/

#if !defined(MACRO_PLX)
#define MACRO_PLX
#define ll3macro_name "MACRO"
/* C-interface argument definitions */
#define KILL_MACRO_ARGS (\
 lptr(CONTEXT) LpiContext)
#define LPI_MAC_MACRORUN_STR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) instr,\
 lptr(lushort) apperror)
#define LPI_MAC_MACRORUN_STR_ARRAY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmhdl(lmbcs)) script,\
 lslong size,\
 lslong state,\
 lptr(lushort) apperror)
#define LPI_MAC_MACRORUN_CELL_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiCellType clMptr,\
 lptr(lushort) apperror)
#define LPI_MAC_MACRORUN_RANGE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType rgMptr,\
 lptr(lushort) apperror)
#define LPI_MAC_GET_MENUSTRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lushort resid,\
 lptr(lmhdl(lmbcs)) buffer)
/* C-interface function prototypes */
lexppro (lsshort, kill_macro, KILL_MACRO_ARGS);
lexppro (lsshort, lpi_mac_macrorun_str, LPI_MAC_MACRORUN_STR_ARGS);
lexppro (lsshort, lpi_mac_macrorun_str_array, LPI_MAC_MACRORUN_STR_ARRAY_ARGS);
lexppro (lsshort, lpi_mac_macrorun_cell, LPI_MAC_MACRORUN_CELL_ARGS);
lexppro (lsshort, lpi_mac_macrorun_range, LPI_MAC_MACRORUN_RANGE_ARGS);
lexppro (lsshort, lpi_mac_get_menustring, LPI_MAC_GET_MENUSTRING_ARGS);
typedef struct
 {
   lexpptr (lsshort, kill_macro, KILL_MACRO_ARGS);
   lexpptr (lsshort, lpi_mac_macrorun_str, LPI_MAC_MACRORUN_STR_ARGS);
   lexpptr (lsshort, lpi_mac_macrorun_str_array, LPI_MAC_MACRORUN_STR_ARRAY_ARGS);
   lexpptr (lsshort, lpi_mac_macrorun_cell, LPI_MAC_MACRORUN_CELL_ARGS);
   lexpptr (lsshort, lpi_mac_macrorun_range, LPI_MAC_MACRORUN_RANGE_ARGS);
   lexpptr (lsshort, lpi_mac_get_menustring, LPI_MAC_GET_MENUSTRING_ARGS);
 } mac_exports;
#define ll3macro_kill_macro(xStructure, xLpiContext) \
   (*xStructure->kill_macro) (xLpiContext)
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_MAC_GLOBAL_REF  LPI_CALL_DATA->mac_global
#define LPI_MAC_TABLE_REF   LPI_CALL_DATA->mac_table
#else
#define LPI_MAC_GLOBAL_REF  lts_mac_global
#define LPI_MAC_TABLE_REF   lts_mac_table
#endif
#define LpiMacMacroRunString(arg1, arg2)                           \
        (*LPI_MAC_TABLE_REF->lpi_mac_macrorun_str)       \
        (LPI_MAC_GLOBAL_REF, arg1, arg2)
#define LpiMacMacroRunStringArray(arg1, arg2, arg3)             \
        (*LPI_MAC_TABLE_REF->lpi_mac_macrorun_str_array) \
        (LPI_MAC_GLOBAL_REF, arg1, arg2, 0L, arg3)
#define LpiMacMacroRunCell(arg1, arg2)                          \
        (*LPI_MAC_TABLE_REF->lpi_mac_macrorun_cell)      \
        (LPI_MAC_GLOBAL_REF, arg1, arg2)
#define LpiMacMacroRunRange(arg1, arg2)                         \
        (*LPI_MAC_TABLE_REF->lpi_mac_macrorun_range)     \
        (LPI_MAC_GLOBAL_REF, arg1, arg2)
#define LpiMacGetMenuString(arg1, arg2)                         \
        (*LPI_MAC_TABLE_REF->lpi_mac_get_menustring)     \
        (LPI_MAC_GLOBAL_REF, arg1, arg2)
#endif
#endif
