/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  workfile.plx

\***************************************************************************/

#if !defined(WORKFILE_PLX)
#define WORKFILE_PLX
#define ll3wfile_name "WORKFILE"
/* Argument definitions for C-callable functions */
#define LPI_WF_CONST_FILENAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWorkfileType) mwfile,\
 lmhdl(lmbcs) mpfname)
#define LPI_WF_CONST_CURRENT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWorkfileType) mwfile,\
 lptr(lushort) apperror)
#define LPI_WF_DEST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWorkfileType) mwfile)
#define LPI_WF_GET_ACTIVE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) active)
#define LPI_WF_GET_CHANGED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) changed)
#define LPI_WF_GET_GROUPED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) grouped)
#define LPI_WF_SET_GROUPED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort grouped)
#define LPI_WF_GET_NAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) name)
#define LPI_WF_GET_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) extension)
#define LPI_WF_GET_PATH_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) path)
#define LPI_WF_GET_FULL_NAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) full_name)
#define LPI_WF_GET_SHEETS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) totalSheets)
#define LPI_WF_GET_CALC_METHOD_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) calcmode,\
 lptr(lushort) apperror)
#define LPI_WF_SET_CALC_METHOD_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort calcmethod,\
 lptr(lushort) apperror)
#define LPI_WF_GET_CALC_ORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) calc_order,\
 lptr(lushort) apperror)
#define LPI_WF_SET_CALC_ORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort calc_order,\
 lptr(lushort) apperror)
#define LPI_WF_GET_CALC_ITERATIONS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) calciter,\
 lptr(lushort) apperror)
#define LPI_WF_SET_CALC_ITERATIONS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lslong NewIterations,\
 lptr(lushort) apperror)
#define LPI_WF_SET_RESERVED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lbool getReservation,\
 lptr(lushort) apperror)
#define LPI_WF_GET_RESERVED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lbool) isReserved)
#define LPI_WF_SET_RESERVATION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort mode,\
 lptr(lushort) apperror)
#define LPI_WF_GET_RESERVATION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) mode)
#define LPI_WF_SET_SEAL_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort wfseal,\
 lmhdl(lmbcs) wfpword,\
 lptr(lushort) apperror)
#define LPI_WF_GET_SEAL_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) wfseal)
#define LPI_WF_RETRIEVE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort reqtype,\
 lmhdl(lmbcs) mppassword,\
 lptr(lushort) apperror)
#define LPI_WF_DELETE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lushort) apperror)
#define LPI_WF_FILE_NEW_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort postype,\
 lptr(lushort) apperror)
#define LPI_WF_FILE_OPEN_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lushort reqtype,\
 lushort postype,\
 lmhdl(lmbcs) mppassword,\
 lptr(lushort) apperror)
#define LPI_WF_INSERT_SHEET_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lslong sheet,\
 lslong sheetCount,\
 lushort position,\
 lptr(lushort) apperror)
#define LPI_WF_DELETE_SHEET_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lslong sheet,\
 lslong sheetCount,\
 lptr(lushort) apperror)
#define LPI_WF_SAVE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType theWfileMhdl,\
 lmhdl(lmbcs) password_mptr,\
 lmhdl(lmbcs) newfnameMptr,\
 lushort option,\
 lptr(lushort) apperror)
#define LPI_WF_ERASE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType theWfileMhdl,\
 lptr(lushort) apperror)
#define LPI_WF_IMPORT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType theWfileMhdl,\
 lmhdl(lmbcs) fnameMptr,\
 lushort data,\
 lptr(lushort) apperror)
#define LPI_WF_COMBINE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType theWfileMhdl,\
 lmhdl(lmbcs) password,\
 lmhdl(lmbcs) rngname,\
 lushort option,\
 lptr(lushort) apperror)
#define LPI_WF_EXTRACT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType theWfileMhdl,\
 lmhdl(lmbcs) rngname,\
 lushort data,\
 lmhdl(lmbcs) newfname_mptr,\
 lmhdl(lmbcs) password_mptr,\
 lptr(lushort) apperror)
#define LPI_WF_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) fname)
#define LPI_WF_LAST_CELL_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) celladdr)
#define LPI_WF_LAST_CELL_COORDS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkfileType mwfile,\
 lptr(lmhdl(lmbcs)) filestr,\
 lptr(lushort) sheet_num,\
 lptr(lushort) col_num,\
 lptr(lushort) row_num)
/* typedefs for C callable functions */
lexppro (lsshort, lpi_wf_const_filename, LPI_WF_CONST_FILENAME_ARGS);
lexppro (lsshort, lpi_wf_const_current, LPI_WF_CONST_CURRENT_ARGS);
lexppro (lsshort, lpi_wf_dest, LPI_WF_DEST_ARGS);
lexppro (lsshort, lpi_wf_get_active, LPI_WF_GET_ACTIVE_ARGS);
lexppro (lsshort, lpi_wf_get_changed, LPI_WF_GET_CHANGED_ARGS);
lexppro (lsshort, lpi_wf_get_grouped, LPI_WF_GET_GROUPED_ARGS);
lexppro (lsshort, lpi_wf_set_grouped, LPI_WF_SET_GROUPED_ARGS);
lexppro (lsshort, lpi_wf_get_name, LPI_WF_GET_NAME_ARGS);
lexppro (lsshort, lpi_wf_get_extension, LPI_WF_GET_EXTENSION_ARGS);
lexppro (lsshort, lpi_wf_get_path, LPI_WF_GET_PATH_ARGS);
lexppro (lsshort, lpi_wf_get_full_name, LPI_WF_GET_FULL_NAME_ARGS);
lexppro (lsshort, lpi_wf_get_sheets, LPI_WF_GET_SHEETS_ARGS);
lexppro (lsshort, lpi_wf_get_calc_method, LPI_WF_GET_CALC_METHOD_ARGS);
lexppro (lsshort, lpi_wf_set_calc_method, LPI_WF_SET_CALC_METHOD_ARGS);
lexppro (lsshort, lpi_wf_get_calc_order, LPI_WF_GET_CALC_ORDER_ARGS);
lexppro (lsshort, lpi_wf_set_calc_order, LPI_WF_SET_CALC_ORDER_ARGS);
lexppro (lsshort, lpi_wf_get_calc_iterations, LPI_WF_GET_CALC_ITERATIONS_ARGS);
lexppro (lsshort, lpi_wf_set_calc_iterations, LPI_WF_SET_CALC_ITERATIONS_ARGS);
lexppro (lsshort, lpi_wf_set_reserved, LPI_WF_SET_RESERVED_ARGS);
lexppro (lsshort, lpi_wf_get_reserved, LPI_WF_GET_RESERVED_ARGS);
lexppro (lsshort, lpi_wf_set_reservation, LPI_WF_SET_RESERVATION_ARGS);
lexppro (lsshort, lpi_wf_get_reservation, LPI_WF_GET_RESERVATION_ARGS);
lexppro (lsshort, lpi_wf_set_seal, LPI_WF_SET_SEAL_ARGS);
lexppro (lsshort, lpi_wf_get_seal, LPI_WF_GET_SEAL_ARGS);
lexppro (lsshort, lpi_wf_retrieve, LPI_WF_RETRIEVE_ARGS);
lexppro (lsshort, lpi_wf_delete, LPI_WF_DELETE_ARGS);
lexppro (lsshort, lpi_wf_file_new, LPI_WF_FILE_NEW_ARGS);
lexppro (lsshort, lpi_wf_file_open, LPI_WF_FILE_OPEN_ARGS);
lexppro (lsshort, lpi_wf_insert_sheet, LPI_WF_INSERT_SHEET_ARGS);
lexppro (lsshort, lpi_wf_delete_sheet, LPI_WF_DELETE_SHEET_ARGS);
lexppro (lsshort, lpi_wf_save, LPI_WF_SAVE_ARGS);
lexppro (lsshort, lpi_wf_import, LPI_WF_IMPORT_ARGS);
lexppro (lsshort, lpi_wf_erase, LPI_WF_ERASE_ARGS);
lexppro (lsshort, lpi_wf_combine, LPI_WF_COMBINE_ARGS);
lexppro (lsshort, lpi_wf_extract, LPI_WF_EXTRACT_ARGS);
lexppro (lsshort, lpi_wf_string, LPI_WF_STRING_ARGS);
lexppro (lsshort, lpi_wf_last_cell_string, LPI_WF_LAST_CELL_STRING_ARGS);
lexppro (lsshort, lpi_wf_last_cell_coords, LPI_WF_LAST_CELL_COORDS_ARGS);
/* pointers to C callable functions */
typedef struct {
    lexpptr (lsshort, lpi_wf_const_filename, LPI_WF_CONST_FILENAME_ARGS);
    lexpptr (lsshort, lpi_wf_const_current, LPI_WF_CONST_CURRENT_ARGS);
    lexpptr (lsshort, lpi_wf_dest, LPI_WF_DEST_ARGS);
    lexpptr (lsshort, lpi_wf_get_active, LPI_WF_GET_ACTIVE_ARGS);
    lexpptr (lsshort, lpi_wf_get_changed, LPI_WF_GET_CHANGED_ARGS);
    lexpptr (lsshort, lpi_wf_get_grouped, LPI_WF_GET_GROUPED_ARGS);
    lexpptr (lsshort, lpi_wf_set_grouped, LPI_WF_SET_GROUPED_ARGS);
    lexpptr (lsshort, lpi_wf_get_name, LPI_WF_GET_NAME_ARGS);
    lexpptr (lsshort, lpi_wf_get_extension, LPI_WF_GET_EXTENSION_ARGS);
    lexpptr (lsshort, lpi_wf_get_path, LPI_WF_GET_PATH_ARGS);
    lexpptr (lsshort, lpi_wf_get_full_name, LPI_WF_GET_FULL_NAME_ARGS);
    lexpptr (lsshort, lpi_wf_get_sheets, LPI_WF_GET_SHEETS_ARGS);
    lexpptr (lsshort, lpi_wf_get_calc_method, LPI_WF_GET_CALC_METHOD_ARGS);
    lexpptr (lsshort, lpi_wf_set_calc_method, LPI_WF_SET_CALC_METHOD_ARGS);
    lexpptr (lsshort, lpi_wf_get_calc_order, LPI_WF_GET_CALC_ORDER_ARGS);
    lexpptr (lsshort, lpi_wf_set_calc_order, LPI_WF_SET_CALC_ORDER_ARGS);
    lexpptr (lsshort, lpi_wf_get_calc_iterations, LPI_WF_GET_CALC_ITERATIONS_ARGS);
    lexpptr (lsshort, lpi_wf_set_calc_iterations, LPI_WF_SET_CALC_ITERATIONS_ARGS);
    lexpptr (lsshort, lpi_wf_set_reserved, LPI_WF_SET_RESERVED_ARGS);
    lexpptr (lsshort, lpi_wf_get_reserved, LPI_WF_GET_RESERVED_ARGS);
    lexpptr (lsshort, lpi_wf_set_reservation, LPI_WF_SET_RESERVATION_ARGS);
    lexpptr (lsshort, lpi_wf_get_reservation, LPI_WF_GET_RESERVATION_ARGS);
    lexpptr (lsshort, lpi_wf_set_seal, LPI_WF_SET_SEAL_ARGS);
    lexpptr (lsshort, lpi_wf_get_seal, LPI_WF_GET_SEAL_ARGS);
    lexpptr (lsshort, lpi_wf_retrieve, LPI_WF_RETRIEVE_ARGS);
    lexpptr (lsshort, lpi_wf_delete, LPI_WF_DELETE_ARGS);
    lexpptr (lsshort, lpi_wf_file_new, LPI_WF_FILE_NEW_ARGS);
    lexpptr (lsshort, lpi_wf_file_open, LPI_WF_FILE_OPEN_ARGS);
    lexpptr (lsshort, lpi_wf_insert_sheet, LPI_WF_INSERT_SHEET_ARGS);
    lexpptr (lsshort, lpi_wf_delete_sheet, LPI_WF_DELETE_SHEET_ARGS);
    lexpptr (lsshort, lpi_wf_save, LPI_WF_SAVE_ARGS);
    lexpptr (lsshort, lpi_wf_import, LPI_WF_IMPORT_ARGS);
    lexpptr (lsshort, lpi_wf_erase, LPI_WF_ERASE_ARGS);
    lexpptr (lsshort, lpi_wf_combine, LPI_WF_COMBINE_ARGS);
    lexpptr (lsshort, lpi_wf_extract, LPI_WF_EXTRACT_ARGS);
    lexpptr (lsshort, lpi_wf_string, LPI_WF_STRING_ARGS);
    lexpptr (lsshort, lpi_wf_last_cell_string, LPI_WF_LAST_CELL_STRING_ARGS);
    lexpptr (lsshort, lpi_wf_last_cell_coords, LPI_WF_LAST_CELL_COORDS_ARGS);
} wf_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_WF_GLOBAL_REF  LPI_CALL_DATA->wf_global
#define LPI_WF_TABLE_REF   LPI_CALL_DATA->wf_table
#else
#define LPI_WF_GLOBAL_REF  lts_wf_global
#define LPI_WF_TABLE_REF   lts_wf_table
#endif
#define LpiWfConstructFilename(xADTdata, arg1)                      \
            (*LPI_WF_TABLE_REF->lpi_wf_const_filename)       \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfConstructCurrent(xADTdata, arg1)                       \
            (*LPI_WF_TABLE_REF->lpi_wf_const_current)        \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfDestroy(xADTdata)                                      \
            (*LPI_WF_TABLE_REF->lpi_wf_dest)                 \
        (LPI_WF_GLOBAL_REF, xADTdata)
#define LpiWfGetActive(xADTdata, arg1)                              \
            (*LPI_WF_TABLE_REF->lpi_wf_get_active)           \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetChanged(xADTdata, arg1)                             \
            (*LPI_WF_TABLE_REF->lpi_wf_get_changed)          \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetGrouped(xADTdata, arg1)                             \
            (*LPI_WF_TABLE_REF->lpi_wf_get_grouped)          \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfSetGrouped(xADTdata, arg1)                             \
            (*LPI_WF_TABLE_REF->lpi_wf_set_grouped)          \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetName(xADTdata, arg1)                                \
            (*LPI_WF_TABLE_REF->lpi_wf_get_name)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetExtension(xADTdata, arg1)                           \
            (*LPI_WF_TABLE_REF->lpi_wf_get_extension)        \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetPath(xADTdata, arg1)                                \
            (*LPI_WF_TABLE_REF->lpi_wf_get_path)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetFullName(xADTdata, arg1)                            \
            (*LPI_WF_TABLE_REF->lpi_wf_get_full_name)        \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetSheets(xADTdata, arg1)                              \
            (*LPI_WF_TABLE_REF->lpi_wf_get_sheets)           \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfGetCalcMethod(xADTdata, arg1, arg2)                    \
            (*LPI_WF_TABLE_REF->lpi_wf_get_calc_method)      \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfSetCalcMethod(xADTdata, arg1, arg2)                    \
            (*LPI_WF_TABLE_REF->lpi_wf_set_calc_method)      \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfGetCalcOrder(xADTdata, arg1, arg2)                     \
            (*LPI_WF_TABLE_REF->lpi_wf_get_calc_order)       \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfSetCalcOrder(xADTdata, arg1, arg2)                     \
            (*LPI_WF_TABLE_REF->lpi_wf_set_calc_order)       \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfGetCalcIterations(xADTdata, arg1, arg2)                \
            (*LPI_WF_TABLE_REF->lpi_wf_get_calc_iterations)  \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfSetCalcIterations(xADTdata, arg1, arg2)                \
            (*LPI_WF_TABLE_REF->lpi_wf_set_calc_iterations)  \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfSetReserved(xADTdata, lbool, arg1)                     \
            (*LPI_WF_TABLE_REF->lpi_wf_set_reserved)         \
        (LPI_WF_GLOBAL_REF, xADTdata, lbool, arg1)
#define LpiWfGetReserved(xADTdata, arg1)                            \
            (*LPI_WF_TABLE_REF->lpi_wf_get_reserved)         \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfSetReservation(xADTdata, arg1, arg2)                   \
            (*LPI_WF_TABLE_REF->lpi_wf_set_reservation)      \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfGetReservation(xADTdata, arg1)                         \
            (*LPI_WF_TABLE_REF->lpi_wf_get_reservation)      \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfSetSeal(xADTdata, arg1, arg2, arg3)                    \
            (*LPI_WF_TABLE_REF->lpi_wf_set_seal)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiWfGetSeal(xADTdata, arg1)                                \
            (*LPI_WF_TABLE_REF->lpi_wf_get_seal)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfRetrieve(xADTdata, arg1, arg2)                         \
            (*LPI_WF_TABLE_REF->lpi_wf_retrieve)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, LNULL, arg2)
#define LpiWfRetrievePass(xADTdata, arg1, arg2, arg3)               \
            (*LPI_WF_TABLE_REF->lpi_wf_retrieve)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiWfDelete(xADTdata, arg1)                                 \
            (*LPI_WF_TABLE_REF->lpi_wf_delete)               \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfFileNew(xADTdata, arg1, arg2)                          \
            (*LPI_WF_TABLE_REF->lpi_wf_file_new)             \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWfFileOpen(xADTdata, arg1, arg2, arg3)                   \
            (*LPI_WF_TABLE_REF->lpi_wf_file_open)            \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, LNULL, arg3)
#define LpiWfFileOpenPass(xADTdata, arg1, arg2, arg3, arg4)         \
            (*LPI_WF_TABLE_REF->lpi_wf_file_open)            \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4)
#define LpiWfInsertSheet(xADTdata, arg1, arg2, arg3, arg4)          \
            (*LPI_WF_TABLE_REF->lpi_wf_insert_sheet)         \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4)
#define LpiWfDeleteSheet(xADTdata, arg1, arg2, arg3)                \
            (*LPI_WF_TABLE_REF->lpi_wf_delete_sheet)         \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiWfSave(xADTdata, arg1, arg2)                             \
            (*LPI_WF_TABLE_REF->lpi_wf_save)                 \
        (LPI_WF_GLOBAL_REF, xADTdata, LNULL, LNULL, arg1, arg2)
#define LpiWfSavePass(xADTdata, arg1, arg2, arg3)                   \
            (*LPI_WF_TABLE_REF->lpi_wf_save)                 \
        (LPI_WF_GLOBAL_REF, xADTdata, arg2, LNULL, arg1, arg3)
#define LpiWfSaveName(xADTdata, arg1, arg2, arg3)                   \
            (*LPI_WF_TABLE_REF->lpi_wf_save)                 \
        (LPI_WF_GLOBAL_REF, xADTdata, LNULL, arg2, arg1, arg3)
#define LpiWfSavePassName(xADTdata, arg1, arg2, arg3, arg4)         \
            (*LPI_WF_TABLE_REF->lpi_wf_save)                 \
        (LPI_WF_GLOBAL_REF, xADTdata, arg2, arg3, arg1, arg4)
#define LpiWfImport(xADTdata, arg1, arg2, arg3)                     \
            (*LPI_WF_TABLE_REF->lpi_wf_import)               \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiWfErase(xADTdata, arg1)                                  \
            (*LPI_WF_TABLE_REF->lpi_wf_erase)                \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfCombine(xADTdata, arg1, arg2)                          \
            (*LPI_WF_TABLE_REF->lpi_wf_combine)              \
        (LPI_WF_GLOBAL_REF, xADTdata, LNULL, LNULL, arg1, arg2)
#define LpiWfCombinePass(xADTdata, arg1, arg2, arg3)                \
            (*LPI_WF_TABLE_REF->lpi_wf_combine)              \
        (LPI_WF_GLOBAL_REF, xADTdata, arg2, LNULL, arg1, arg3)
#define LpiWfCombineRange(xADTdata, arg1, arg2, arg3)               \
            (*LPI_WF_TABLE_REF->lpi_wf_combine)              \
        (LPI_WF_GLOBAL_REF, xADTdata, LNULL, arg2, arg1, arg3)
#define LpiWfCombinePassRange(xADTdata, arg1, arg2, arg3, arg4)     \
            (*LPI_WF_TABLE_REF->lpi_wf_combine)              \
        (LPI_WF_GLOBAL_REF, xADTdata, arg2, arg3, arg1, arg4)
#define LpiWfExtract(xADTdata, arg1, arg2, arg3, arg4)              \
            (*LPI_WF_TABLE_REF->lpi_wf_extract)              \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3, LNULL, arg4)
#define LpiWfExtractPass(xADTdata, arg1, arg2, arg3, arg4, arg5)    \
            (*LPI_WF_TABLE_REF->lpi_wf_extract)              \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4, arg5)
#define LpiWfString(xADTdata, arg1)                                 \
            (*LPI_WF_TABLE_REF->lpi_wf_string)               \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfLastCellString(xADTdata, arg1)                         \
            (*LPI_WF_TABLE_REF->lpi_wf_last_cell_string)     \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1)
#define LpiWfLastCellCoords(xADTdata, arg1, arg2, arg3, arg4)       \
            (*LPI_WF_TABLE_REF->lpi_wf_last_cell_coords)     \
        (LPI_WF_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4)
#endif
#endif
