@goto start
:start
@echo OFF
if "%echo_flag%"=="" set echo_flag=OFF
@echo %echo_flag%

rem  Make a directory and copy the ADK for 123R4 to it
rem ******************************
rem Check Command Line Parameters
rem ******************************
   if "%1" == ""    goto usage
   if "%1" == "-h"  goto usage
   if "%1" == "-H"  goto usage
   if "%1" == "?"   goto usage

   if not exist %2\l123r3.plc goto nolibs
   if not exist %2\123r4.ico  goto wrong123

   set XADKDIR=%1
   set X123DIR=%2
   goto MAININST


:MAININST
@echo.
@echo -Copy the ADK for 123R4 to %1
@echo -in directories ADKEXE, ADKSMPL, ADKINC and ADKLIB?
@echo.
@echo.
@echo -The 123R4 executables are in %2?
@goto confirm

:confirm
@echo.
@echo CTRL BREAK to exit without copying or
pause

md %1
@rem  make the root directory

for %%f in (install.bat readme.txt instcopy.bat) do copy %%f %1
if errorlevel goto nocopy
if not exist %1\readme.txt goto nocopy
for %%f in (whatsnew.doc c_adts.doc c_to_c.doc) do call instcopy . %%f %1 .


@set XTARGDIR=adkexe
md %1\%XTARGDIR%
@set XSRCDIR=exe

for %%f in (lpl.ico lpl.pif lpl.ri lpldos.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpl.exe ldebug.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (ldebug.hlp ldebug.ico ldebug.pif) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (ldbg_err.ri ldbg_hlp.ri ldbg_msg.ri) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@if not exist 5HI goto nopas51
echo.
echo Please put diskette #2 in the source drive
pause and strike any key to continue.

:nopas51
@set XTARGDIR=adksmpl
md %1\%XTARGDIR%

set XSRCDIR=samples
for %%f in (autosave.pl autosave.plc eventerr.pl) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (celldem.pl celldem.plc celldem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (date.pl date.plc examples.doc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (toupper.pl toupper.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (dispdem.pl dispdem.plc dispdem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (filedem.pl filedem.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (filedem.txt filedem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (keydem.pl keydem.plc keydem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (macrange.pl macrange.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (measure.pl measure.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (median.pl median.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (menudem.pl menudem.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (prmptdem.pl prmptdem.plc prmptdem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (rangedem.pl rangedem.plc rangedem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (sheetdem.pl sheetdem.plc sheetdem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (wfiledem.pl wfiledem.plc wfiledem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (windem.pl windem.plc windem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (wkspcdem.pl wkspcdem.plc wkspcdem.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (xalert.pl xalert.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (xdegrees.pl xdegrees.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@if %2.==. goto nocnf
echo -U %2 >%1\%XTARGDIR%\lpl.cnf
echo -U %2 >%1\%XTARGDIR%\describe.cnf

:nocnf
echo path %path% >%1\%XTARGDIR%\stdenv.bat
echo set include=%include% >>%1\%XTARGDIR%\stdenv.bat
echo set lib=%lib% >>%1\%XTARGDIR%\stdenv.bat

echo @rem Batch file to set up development environment for LPL > %1\%XTARGDIR%\lplenv.bat
echo @rem Modify stdenv.bat as necessary for your environment >> %1\%XTARGDIR%\lplenv.bat
echo call stdenv  >> %1\%XTARGDIR%\lplenv.bat
echo path %1\adkexe;%%path%% >> %1\%XTARGDIR%\lplenv.bat
echo set include=%1\adkinc;%%include%% >> %1\%XTARGDIR%\lplenv.bat
echo set lib=%1\adklib;%%lib%% >> %1\%XTARGDIR%\lplenv.bat

@rem  samples using the LPI C interface follow

for %%f in (commpdos.asm comxport.h commport.c) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (commport.nmk commport.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (commport.pl commport.plc commport.plh) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (commport.dld commport.obj commpdos.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (newtrap.c newtrap.pl newtrap.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (newtrap.obj newtrap.dld newtrap.nmk) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (newt_raa.asm newt_raa.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (nraph.pl nraph.plc newtrap.plh) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (sumsq.c sumsq.pl sumsq.plc sumsq.plh) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (sumsq.obj sumsq.dld) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (sumsqasm.asm sumsqasm.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (tstsumsq.pl tstsumsq.plc tstsumsq.wk3) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (templasm.asm template.c template.nmk) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (widthx2.c widthx2.nmk widthx2.pl) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (tstwidth.pl tstwidth.plc widthx2.plc) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (widthasm.asm widthasm.obj widthx2.plh) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@if not exist 3HI goto nopas35
echo.
echo Please put diskette #2 in the source drive
pause and strike any key to continue.

:nopas35
@set XTARGDIR=adkexe
@set XSRCDIR=cexe

for %%f in (describe.exe lplfree.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lplresrv.exe debug16m.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%

for %%f in (debugon.bat debugoff.bat) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (d123.bat l123.bat) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@if not exist 5HI goto nopas52
echo.
echo Please put diskette #3 in the source drive
pause and strike any key to continue.

:nopas52
@set XTARGDIR=adkexe
@set XSRCDIR=rational

for %%f in (d.exe m2dbg.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (palin2.cv palin2.exe palindr.cv) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (palindr.dbg palindr.dbl palindr.exe) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (palindr.map palindr.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@set XTARGDIR=adklib
md %1\%XTARGDIR%
@set XSRCDIR=lib

for %%f in (lpimisc.lib lpimath.lib lplcls.lib) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (fltutil.lib dosdebug.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (acrtused.obj fltused.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%

@set XTARGDIR=adksmpl
for %%f in (acrtused.obj fltused.obj dosdebug.obj) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%


@set XTARGDIR=adkinc
md %1\%XTARGDIR%
@set XSRCDIR=include

for %%f in (atdate.plx atdbase.plx atfin.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (atlogic.plx atspcl.plx atstat.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (atstr.plx cell.plx file.plx input.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (macro.plx range.plx register.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (sheet.plx utility.plx window.plx) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (wkspace.plx workfile.plx debug.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpickstk.h lpicode.h lpienum.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpimemm.h lpimemm.t lpimisc.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpixport.t lstring.h ltscntrl.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (ltscntrl.h ltsdefs.h ltsstrct.h ) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpierror.h lpixport.h lpisys.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%
for %%f in (lpiprim.h) do call instcopy %XSRCDIR% %%f %1 %XTARGDIR%

rem Let's remove the install files.
if exist %1\install.bat del %1\install.bat
if exist %1\instcopy.bat del %1\instcopy.bat

@goto END


rem Error handling
rem The 1-2-3 directory specified is wrong.
:nolibs
@echo.
@echo The 123 executable directory was specified, but the addin library
@echo files could not be found in it.  There are 20 *.plc files and 19
@echo ll3*.dld files that must be in the 123 program directory in order
@echo to run addins.  They are part of 123R4.
@echo.
@goto usage

rem The 1-2-3 version you specified is not 1-2-3 R4.
:wrong123
@echo.
@echo The 123 executable directory was specified, but it is not the
@echo 1-2-3 Release 4 version.  This add-in toolkit works only with
@echo that release.
@echo.
@goto usage

:nomd
:nocopy
@echo.
@echo For some reason the file did not copy.
@echo Possible reasons:  invalid target specification;  target is either
@echo write-protected or full.
@echo.
@goto usage

:usage
@echo.
@echo Use:  %0  Drive-Path-Specification [123 Executables Directory]
@echo  to copy the ADK directories.  If the 123 directory is specified,
@echo  lpl CNF files will be written to the sample directory.
@echo.
@echo e.g.  %0  c:\123r4adk  c:\123r4d
@echo.
@echo.
goto END

:END
@set XSRCDIR=
@set XTARGDIR=
@set XADKDIR=
@set X123DIR=
echo.
echo Done.
echo.

