--**************************************************************************
--
--   Copyright (C) 1991-1994 Lotus Development Corporation.
--   All rights reserved.
--
--   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
--       the source code version and to reproduce and distribute the object
--       code version of the Example Programs provided in the Toolkit, provided
--       that you:
--
--       a) distribute the Example Programs only in conjunction with and as a
--          part of your software application product which is designed as an
--          add-in to Lotus 1-2-3, and
--
--       b) do not represent your product to be a product of Lotus Development
--          Corporation.
--
--   2.  The Example Programs are provided as is, without warranty of any kind,
--       either express or implied, including, without limitation, the implied
--       warranties of merchantability of fitness for a particular purpose.
--
--   File Name:  tstwidth.pl
--
--**************************************************************************

USE widthx2
USE window
USE input

forward procedure alert (string xmessage)

procedure main is

    widthx2 ()
    except on others (string sig_name) do
        alert ("Signal Recieved: " || sig_name)
    end except

end procedure main


private procedure alert (string xmessage) is

    Display [] d
    Window [(d.width div 2), (d.height div 3), double] w
    Prompt ["Hit <enter> to Continue"] p

    w.Position = 10, 6
    w[w.height div 2] = xmessage
    w.Background(Defaultarea) = Flash
    w.Foreground(Defaultarea) = Normal

    show (w)

    string s = Input(p)

end procedure alert
