/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atdbase.plx

\***************************************************************************/

#if !defined(ATDBASE_PLX)
#define ATDBASE_PLX
#define ll3atdbase_name     "ATDBASE"
/* Argument definitions for C-callable functions */
#define LPI_ATDB_DFUNCS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lubyte thefunc,\
 LpiRangeType theTable,\
 lslong theOffset,\
 LpiRangeType theCriteria,\
 lptr(lfloat10) outflt)
#define LPI_ATDB_SDFUNCS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lubyte thefunc,\
 LpiRangeType theTable,\
 lmhdl(lmbcs) theFieldName,\
 LpiRangeType theCriteria,\
 lptr(lfloat10) outflt)
#define LPI_ATDB_DCOUNT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType theTable,\
 lslong theOffset,\
 LpiRangeType theCriteria,\
 lptr(lslong) outint)
#define LPI_ATDB_SDCOUNT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType theTable,\
 lmhdl(lmbcs) theFieldName,\
 LpiRangeType theCriteria,\
 lptr(lslong) outint)
#define LPI_ATDB_DGET_STR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType theTable,\
 lslong theOffset,\
 LpiRangeType theCriteria,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATDB_SDGET_STR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType theTable,\
 lmhdl(lmbcs) theFieldName,\
 LpiRangeType theCriteria,\
 lptr(lmhdl(lmbcs)) outstr)
/* Function prototypes for C-callable functions */
lexppro (lsshort, lpi_atdb_dfuncs, LPI_ATDB_DFUNCS_ARGS);
lexppro (lsshort, lpi_atdb_sdfuncs, LPI_ATDB_SDFUNCS_ARGS);
lexppro (lsshort, lpi_atdb_dcount, LPI_ATDB_DCOUNT_ARGS);
lexppro (lsshort, lpi_atdb_sdcount, LPI_ATDB_SDCOUNT_ARGS);
lexppro (lsshort, lpi_atdb_dget_str, LPI_ATDB_DGET_STR_ARGS);
lexppro (lsshort, lpi_atdb_sdget_str, LPI_ATDB_SDGET_STR_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_atdb_dfuncs, LPI_ATDB_DFUNCS_ARGS);
    lexpptr (lsshort, lpi_atdb_sdfuncs, LPI_ATDB_SDFUNCS_ARGS);
    lexpptr (lsshort, lpi_atdb_dcount, LPI_ATDB_DCOUNT_ARGS);
    lexpptr (lsshort, lpi_atdb_sdcount, LPI_ATDB_SDCOUNT_ARGS);
    lexpptr (lsshort, lpi_atdb_dget_str, LPI_ATDB_DGET_STR_ARGS);
    lexpptr (lsshort, lpi_atdb_sdget_str, LPI_ATDB_SDGET_STR_ARGS);
} atdb_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#include "LPICODE.H"
#if defined(NOGLOBALDATA)
#define LPI_ATDB_GLOBAL_REF  LPI_CALL_DATA->atdb_global
#define LPI_ATDB_TABLE_REF   LPI_CALL_DATA->atdb_table
#else
#define LPI_ATDB_GLOBAL_REF  lts_atdb_global
#define LPI_ATDB_TABLE_REF   lts_atdb_table
#endif
/* integer version */
#define LpiAtdbDAvg(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DAVG, arg1, arg2, arg3, arg4)
#define LpiAtdbDCount(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dcount)(LPI_ATDB_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdbDGetFloat(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DGET, arg1, arg2, arg3, arg4)
#define LpiAtdbDGetString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dget_str)(LPI_ATDB_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdbDMax(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DMAX, arg1, arg2, arg3, arg4)
#define LpiAtdbDMin(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DMIN, arg1, arg2, arg3, arg4)
#define LpiAtdbDStD(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DSTD, arg1, arg2, arg3, arg4)
#define LpiAtdbDStDS(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DSTDS, arg1, arg2, arg3, arg4)
#define LpiAtdbDSum(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DSUM, arg1, arg2, arg3, arg4)
#define LpiAtdbDVar(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DVAR, arg1, arg2, arg3, arg4)
#define LpiAtdbDVarS(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_dfuncs)(LPI_ATDB_GLOBAL_REF, I_DVARS, arg1, arg2, arg3, arg4)
/* string versions */
#define LpiAtdbDAvgString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DAVG, arg1, arg2, arg3, arg4)
#define LpiAtdbDCountString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdcount)(LPI_ATDB_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdbDGetFloatString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DGET, arg1, arg2, arg3, arg4)
#define LpiAtdbDGetStringString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdget_str)(LPI_ATDB_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdbDMaxString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DMAX, arg1, arg2, arg3, arg4)
#define LpiAtdbDMinString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DMIN, arg1, arg2, arg3, arg4)
#define LpiAtdbDStDString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DSTD, arg1, arg2, arg3, arg4)
#define LpiAtdbDStDSString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DSTDS, arg1, arg2, arg3, arg4)
#define LpiAtdbDSumString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DSUM, arg1, arg2, arg3, arg4)
#define LpiAtdbDVarString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DVAR, arg1, arg2, arg3, arg4)
#define LpiAtdbDVarSString(arg1, arg2, arg3, arg4) \
    (*LPI_ATDB_TABLE_REF->lpi_atdb_sdfuncs)(LPI_ATDB_GLOBAL_REF, I_DVARS, arg1, arg2, arg3, arg4)
#endif
#endif
