/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atlogic.plx

\***************************************************************************/

#if !defined(ATLOGIC_PLX)
#define ATLOGIC_PLX
#define ll3atlogic_name "ATLOGIC"           /* name of primitive module */
/* Argument definitions for C-callable functions */
#define LPI_ATL_ISERR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiCellType theCell,\
 lptr(lbool) result)
#define LPI_ATL_ISNA_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiCellType theCell,\
 lptr(lbool) result)
#define LPI_ATL_ISNUMBER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiCellType theCell,\
 lptr(lbool) result)
#define LPI_ATL_ISRANGE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) theName,\
 lptr(lbool) retval)
#define LPI_ATL_ISSTRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(Cell) theCell,\
 lptr(lbool) result)
/* Function prtotypes for C-callable functions */
lexppro (lsshort, lpi_atl_iserr, LPI_ATL_ISERR_ARGS);
lexppro (lsshort, lpi_atl_isna, LPI_ATL_ISNA_ARGS);
lexppro (lsshort, lpi_atl_isnumber, LPI_ATL_ISNUMBER_ARGS);
lexppro (lsshort, lpi_atl_isrange, LPI_ATL_ISRANGE_ARGS);
lexppro (lsshort, lpi_atl_isstring, LPI_ATL_ISSTRING_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_atl_iserr, LPI_ATL_ISERR_ARGS);
    lexpptr (lsshort, lpi_atl_isna, LPI_ATL_ISNA_ARGS);
    lexpptr (lsshort, lpi_atl_isnumber, LPI_ATL_ISNUMBER_ARGS);
    lexpptr (lsshort, lpi_atl_isrange, LPI_ATL_ISRANGE_ARGS);
    lexpptr (lsshort, lpi_atl_isstring, LPI_ATL_ISSTRING_ARGS);
} atlog_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_ATLOG_GLOBAL_REF  LPI_CALL_DATA->atlog_global
#define LPI_ATLOG_TABLE_REF   LPI_CALL_DATA->atlog_table
#else
#define LPI_ATLOG_GLOBAL_REF  lts_atlog_global
#define LPI_ATLOG_TABLE_REF   lts_atlog_table
#endif
#define LpiAtlIsERR(arg1, arg2 )\
    (*LPI_ATLOG_TABLE_REF->lpi_atl_iserr)(LPI_ATLOG_GLOBAL_REF, arg1, arg2)
#define LpiAtlIsNA(arg1, arg2 )\
    (*LPI_ATLOG_TABLE_REF->lpi_atl_isna)(LPI_ATLOG_GLOBAL_REF, arg1, arg2)
#define LpiAtlIsNumber(arg1, arg2 )\
    (*LPI_ATLOG_TABLE_REF->lpi_atl_isnumber)(LPI_ATLOG_GLOBAL_REF, arg1, arg2)
#define LpiAtlIsRange(arg1, arg2 )\
    (*LPI_ATLOG_TABLE_REF->lpi_atl_isrange)(LPI_ATLOG_GLOBAL_REF, arg1, arg2)
#define LpiAtlIsString(arg1, arg2 )\
    (*LPI_ATLOG_TABLE_REF->lpi_atl_isstring)(LPI_ATLOG_GLOBAL_REF, arg1, arg2)
#endif
#endif
