/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  cell.plx

\***************************************************************************/

#if !defined(CELL_PLX)
#define CELL_PLX
#define ll3cell_name    "CELL"
/* C callable function typedefs */
#define CL_CONSTRUCT_CURRENT_ARGS (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell)
#define CL_CONSTRUCT_STRING_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell,         \
                                   lmhdl(lmbcs)       theAddrMptr)
#define CL_CONSTRUCT_XY_ARGS      (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell,         \
                                   lulong            x,                 \
                                   lulong            y)
#define CL_CONSTRUCT_ZXY_ARGS     (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell,         \
                                   lulong            z,                 \
                                   lulong            x,                 \
                                   lulong            y)
#define CL_CONSTRUCT_WZXY_ARGS    (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell,         \
                                   lmhdl(lmbcs)       w,                 \
                                   lulong            z,                 \
                                   lulong            x,                 \
                                   lulong            y)
#define CL_CONSTRUCT_CONTEXT_ARGS (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_newCell,         \
                                   lushort           theContext)
#define CL_DESTROY_ARGS           (lptr(CONTEXT)     LpiContext,        \
                                   lptr(LpiCellType) p_theCell)
#define CL_STRING_ARGS            (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lmbcs)        p_dispBuf)
#define CL_GET_ISVALID_ARGS       (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lbool)       p_theResult)
#define CL_GET_CELLTYPE_ARGS      (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_theType)
#define CL_GET_DATATYPE_ARGS      (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_theType)
#define CL_GET_COORDS_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_z,               \
                                   lptr(lushort)     p_x,               \
                                   lptr(lushort)     p_y)
#define CL_GET_COLUMN_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_x)
#define CL_SET_COLUMN_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lulong            x)
#define CL_GET_ROW_ARGS           (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_y)
#define CL_SET_ROW_ARGS           (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lulong            y)
#define CL_GET_SHEET_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_z)
#define CL_SET_SHEET_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lulong            z)
#define CL_GET_WFILE_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lmbcs)        p_theFilename)
#define CL_SET_WFILE_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lmhdl(lmbcs)       theFilename)
#define CL_NEXT_SHEET_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell)
#define CL_PREV_SHEET_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell)
#define CL_GET_WIDTH_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_theWidth,        \
                                   lushort           whichWindow)
#define CL_SET_WIDTH_ARGS         (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lulong            theWidth,          \
                                   lushort           whichWindow)
#define CL_RESET_WIDTH_ARGS       (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lushort           whichWindow)
#define CL_GET_FORMAT_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_theFormat,       \
                                   lptr(lushort)     p_thePlaces)
#define CL_SET_FORMAT_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lushort           theFormat,         \
                                   lulong            thePlaces,         \
                                   lptr(lushort)     p_theErrorCode)
#define CL_GET_LABEL_PREFIX_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_thePrefix)
#define CL_SET_LABEL_PREFIX_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lushort           thePrefix)
#define CL_GET_PROTECTION_ARGS    (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lbool)       p_theSetting)
#define CL_SET_PROTECTION_ARGS    (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lbool             theSetting,        \
                                   lptr(lushort)     p_theErrorCode)
#define CL_GET_PARENTHESES_ARGS   (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lbool)       p_theSetting)
#define CL_SET_PARENTHESES_ARGS   (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lbool             theSetting,        \
                                   lptr(lushort)     p_theErrorCode)
#define CL_GET_COLOR_NEG_ARGS     (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lbool)       p_theSetting)
#define CL_SET_COLOR_NEG_ARGS     (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lbool             theSetting,        \
                                   lptr(lushort)     p_theErrorCode)
#define CL_GET_HIGHLIGHT_ARGS     (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lbool)       p_theSetting)
#define CL_SET_HIGHLIGHT_ARGS     (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lbool             theSetting,        \
                                   lptr(lushort)     p_theErrorCode)
#define CL_GET_VALUE_FLOAT_ARGS   (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lfloat10)    p_theFloat)
#define CL_SET_VALUE_FLOAT_ARGS   (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lfloat10          theValue)
#define CL_GET_VALUE_STRING_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lmbcs)        p_theString)
#define CL_SET_VALUE_STRING_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lmhdl(lmbcs)       theValue)
#define CL_GET_CONTENTS_ARGS      (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lmbcs)        p_theContents)
#define CL_SET_CONTENTS_ARGS      (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lmhdl(lmbcs)       theContents,       \
                                   lptr(lushort)     p_theErrorCode)
#define CL_COPY_ARGS              (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theFromCell,       \
                                   LpiCellType       theToCell,         \
                                   lptr(lushort)     p_theErrorCode)
#define CL_MOVE_ARGS              (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theFromCell,       \
                                   LpiCellType       theToCell,         \
                                   lptr(lushort)     p_theErrorCode)
#define CL_ERASE_ARGS             (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lptr(lushort)     p_theErrorCode)
#define CL_FORMAT_ROW_ARGS        (lptr(CONTEXT)     LpiContext,        \
                                   LpiCellType       theCell,           \
                                   lulong            ncols,             \
                                   lptr(lmbcs)        p_outBuf,          \
                                   lushort           whichWindow)
#define CL_FORMAT_VAL_INT_ARGS    (lptr(CONTEXT)     LpiContext,        \
                                   lptr(lmbcs)        p_theDisplayText,  \
                                   lslong            theValue,          \
                                   lushort           theFormat,         \
                                   lulong            theWidth,          \
                                   lulong            thePlaces)
#define CL_FORMAT_VAL_FLOAT_ARGS  (lptr(CONTEXT)     LpiContext,        \
                                   lptr(lmbcs)        p_theDisplayText,  \
                                   lfloat10          theValue,          \
                                   lushort           theFormat,         \
                                   lulong            theWidth,          \
                                   lulong            thePlaces)
#define CL_FORMAT_VAL_STR_ARGS    (lptr(CONTEXT)     LpiContext,        \
                                   lptr(lmbcs)        p_theDisplayText,  \
                                   lmhdl(lmbcs)       theValue,          \
                                   lushort           theFormat,         \
                                   lulong            theWidth)          \
/* C callable function pointer table */
typedef struct {
    lexpptr (lsshort, lpi_cl_construct_current, CL_CONSTRUCT_CURRENT_ARGS);
    lexpptr (lsshort, lpi_cl_construct_string,  CL_CONSTRUCT_STRING_ARGS);
    lexpptr (lsshort, lpi_cl_construct_xy,      CL_CONSTRUCT_XY_ARGS);
    lexpptr (lsshort, lpi_cl_construct_zxy,     CL_CONSTRUCT_ZXY_ARGS);
    lexpptr (lsshort, lpi_cl_construct_wzxy,    CL_CONSTRUCT_WZXY_ARGS);
    lexpptr (lsshort, lpi_cl_construct_context, CL_CONSTRUCT_CONTEXT_ARGS);
    lexpptr (lsshort, lpi_cl_destroy,           CL_DESTROY_ARGS);
    lexpptr (lsshort, lpi_cl_string,            CL_STRING_ARGS);
    lexpptr (lsshort, lpi_cl_get_isvalid,       CL_GET_ISVALID_ARGS);
    lexpptr (lsshort, lpi_cl_get_celltype,      CL_GET_CELLTYPE_ARGS);
    lexpptr (lsshort, lpi_cl_get_datatype,      CL_GET_DATATYPE_ARGS);
    lexpptr (lsshort, lpi_cl_get_coords,        CL_GET_COORDS_ARGS);
    lexpptr (lsshort, lpi_cl_get_column,        CL_GET_COLUMN_ARGS);
    lexpptr (lsshort, lpi_cl_set_column,        CL_SET_COLUMN_ARGS);
    lexpptr (lsshort, lpi_cl_get_row,           CL_GET_ROW_ARGS);
    lexpptr (lsshort, lpi_cl_set_row,           CL_SET_ROW_ARGS);
    lexpptr (lsshort, lpi_cl_get_sheet,         CL_GET_SHEET_ARGS);
    lexpptr (lsshort, lpi_cl_set_sheet,         CL_SET_SHEET_ARGS);
    lexpptr (lsshort, lpi_cl_get_wfile,         CL_GET_WFILE_ARGS);
    lexpptr (lsshort, lpi_cl_set_wfile,         CL_SET_WFILE_ARGS);
    lexpptr (lsshort, lpi_cl_next_sheet,        CL_NEXT_SHEET_ARGS);
    lexpptr (lsshort, lpi_cl_prev_sheet,        CL_PREV_SHEET_ARGS);
    lexpptr (lsshort, lpi_cl_get_width,         CL_GET_WIDTH_ARGS);
    lexpptr (lsshort, lpi_cl_set_width,         CL_SET_WIDTH_ARGS);
    lexpptr (lsshort, lpi_cl_reset_width,       CL_RESET_WIDTH_ARGS);
    lexpptr (lsshort, lpi_cl_get_format,        CL_GET_FORMAT_ARGS);
    lexpptr (lsshort, lpi_cl_set_format,        CL_SET_FORMAT_ARGS);
    lexpptr (lsshort, lpi_cl_get_label_prefix,  CL_GET_LABEL_PREFIX_ARGS);
    lexpptr (lsshort, lpi_cl_set_label_prefix,  CL_SET_LABEL_PREFIX_ARGS);
    lexpptr (lsshort, lpi_cl_get_protection,    CL_GET_PROTECTION_ARGS);
    lexpptr (lsshort, lpi_cl_set_protection,    CL_SET_PROTECTION_ARGS);
    lexpptr (lsshort, lpi_cl_get_parentheses,   CL_GET_PARENTHESES_ARGS);
    lexpptr (lsshort, lpi_cl_set_parentheses,   CL_SET_PARENTHESES_ARGS);
    lexpptr (lsshort, lpi_cl_get_color_neg,     CL_GET_COLOR_NEG_ARGS);
    lexpptr (lsshort, lpi_cl_set_color_neg,     CL_SET_COLOR_NEG_ARGS);
    lexpptr (lsshort, lpi_cl_get_highlight,     CL_GET_HIGHLIGHT_ARGS);
    lexpptr (lsshort, lpi_cl_set_highlight,     CL_SET_HIGHLIGHT_ARGS);
    lexpptr (lsshort, lpi_cl_get_value_float,   CL_GET_VALUE_FLOAT_ARGS);
    lexpptr (lsshort, lpi_cl_set_value_float,   CL_SET_VALUE_FLOAT_ARGS);
    lexpptr (lsshort, lpi_cl_get_value_string,  CL_GET_VALUE_STRING_ARGS);
    lexpptr (lsshort, lpi_cl_set_value_string,  CL_SET_VALUE_STRING_ARGS);
    lexpptr (lsshort, lpi_cl_get_contents,      CL_GET_CONTENTS_ARGS);
    lexpptr (lsshort, lpi_cl_set_contents,      CL_SET_CONTENTS_ARGS);
    lexpptr (lsshort, lpi_cl_copy,              CL_COPY_ARGS);
    lexpptr (lsshort, lpi_cl_move,              CL_MOVE_ARGS);
    lexpptr (lsshort, lpi_cl_erase,             CL_ERASE_ARGS);
    lexpptr (lsshort, lpi_cl_format_row,        CL_FORMAT_ROW_ARGS);
    lexpptr (lsshort, lpi_cl_format_val_int,    CL_FORMAT_VAL_INT_ARGS);
    lexpptr (lsshort, lpi_cl_format_val_float,  CL_FORMAT_VAL_FLOAT_ARGS);
    lexpptr (lsshort, lpi_cl_format_val_str,    CL_FORMAT_VAL_STR_ARGS);
} cl_exports;
/*-------------------------------------------------------------------------*\
                C Callable Interface Function Prototypes
\*-------------------------------------------------------------------------*/
lexppro (lsshort, lpi_cl_construct_current, CL_CONSTRUCT_CURRENT_ARGS);
lexppro (lsshort, lpi_cl_construct_string,  CL_CONSTRUCT_STRING_ARGS);
lexppro (lsshort, lpi_cl_construct_xy,      CL_CONSTRUCT_XY_ARGS);
lexppro (lsshort, lpi_cl_construct_zxy,     CL_CONSTRUCT_ZXY_ARGS);
lexppro (lsshort, lpi_cl_construct_wzxy,    CL_CONSTRUCT_WZXY_ARGS);
lexppro (lsshort, lpi_cl_construct_context, CL_CONSTRUCT_CONTEXT_ARGS);
lexppro (lsshort, lpi_cl_destroy,           CL_DESTROY_ARGS);
lexppro (lsshort, lpi_cl_string,            CL_STRING_ARGS);
lexppro (lsshort, lpi_cl_get_isvalid,       CL_GET_ISVALID_ARGS);
lexppro (lsshort, lpi_cl_get_celltype,      CL_GET_CELLTYPE_ARGS);
lexppro (lsshort, lpi_cl_get_datatype,      CL_GET_DATATYPE_ARGS);
lexppro (lsshort, lpi_cl_get_coords,        CL_GET_COORDS_ARGS);
lexppro (lsshort, lpi_cl_get_column,        CL_GET_COLUMN_ARGS);
lexppro (lsshort, lpi_cl_set_column,        CL_SET_COLUMN_ARGS);
lexppro (lsshort, lpi_cl_get_row,           CL_GET_ROW_ARGS);
lexppro (lsshort, lpi_cl_set_row,           CL_SET_ROW_ARGS);
lexppro (lsshort, lpi_cl_get_sheet,         CL_GET_SHEET_ARGS);
lexppro (lsshort, lpi_cl_set_sheet,         CL_SET_SHEET_ARGS);
lexppro (lsshort, lpi_cl_get_wfile,         CL_GET_WFILE_ARGS);
lexppro (lsshort, lpi_cl_set_wfile,         CL_SET_WFILE_ARGS);
lexppro (lsshort, lpi_cl_next_sheet,        CL_NEXT_SHEET_ARGS);
lexppro (lsshort, lpi_cl_prev_sheet,        CL_PREV_SHEET_ARGS);
lexppro (lsshort, lpi_cl_get_width,         CL_GET_WIDTH_ARGS);
lexppro (lsshort, lpi_cl_set_width,         CL_SET_WIDTH_ARGS);
lexppro (lsshort, lpi_cl_reset_width,       CL_RESET_WIDTH_ARGS);
lexppro (lsshort, lpi_cl_get_format,        CL_GET_FORMAT_ARGS);
lexppro (lsshort, lpi_cl_set_format,        CL_SET_FORMAT_ARGS);
lexppro (lsshort, lpi_cl_get_label_prefix,  CL_GET_LABEL_PREFIX_ARGS);
lexppro (lsshort, lpi_cl_set_label_prefix,  CL_SET_LABEL_PREFIX_ARGS);
lexppro (lsshort, lpi_cl_get_protection,    CL_GET_PROTECTION_ARGS);
lexppro (lsshort, lpi_cl_set_protection,    CL_SET_PROTECTION_ARGS);
lexppro (lsshort, lpi_cl_get_parentheses,   CL_GET_PARENTHESES_ARGS);
lexppro (lsshort, lpi_cl_set_parentheses,   CL_SET_PARENTHESES_ARGS);
lexppro (lsshort, lpi_cl_get_color_neg,     CL_GET_COLOR_NEG_ARGS);
lexppro (lsshort, lpi_cl_set_color_neg,     CL_SET_COLOR_NEG_ARGS);
lexppro (lsshort, lpi_cl_get_highlight,     CL_GET_HIGHLIGHT_ARGS);
lexppro (lsshort, lpi_cl_set_highlight,     CL_SET_HIGHLIGHT_ARGS);
lexppro (lsshort, lpi_cl_get_value_float,   CL_GET_VALUE_FLOAT_ARGS);
lexppro (lsshort, lpi_cl_set_value_float,   CL_SET_VALUE_FLOAT_ARGS);
lexppro (lsshort, lpi_cl_get_value_string,  CL_GET_VALUE_STRING_ARGS);
lexppro (lsshort, lpi_cl_set_value_string,  CL_SET_VALUE_STRING_ARGS);
lexppro (lsshort, lpi_cl_get_contents,      CL_GET_CONTENTS_ARGS);
lexppro (lsshort, lpi_cl_set_contents,      CL_SET_CONTENTS_ARGS);
lexppro (lsshort, lpi_cl_copy,              CL_COPY_ARGS);
lexppro (lsshort, lpi_cl_move,              CL_MOVE_ARGS);
lexppro (lsshort, lpi_cl_erase,             CL_ERASE_ARGS);
lexppro (lsshort, lpi_cl_format_row,        CL_FORMAT_ROW_ARGS);
lexppro (lsshort, lpi_cl_format_val_int,    CL_FORMAT_VAL_INT_ARGS);
lexppro (lsshort, lpi_cl_format_val_float,  CL_FORMAT_VAL_FLOAT_ARGS);
lexppro (lsshort, lpi_cl_format_val_str,    CL_FORMAT_VAL_STR_ARGS);
/* C callable function macros -- use these to call Cell functions! */
#if defined(LPIXPORT_H)
/* string buffer-length constants (PC only) */
#if (LPI_ENVIRONMENT == LPI_123R3PC)
#define LPI_CL_FILEPATH_BUFLEN 157
#define LPI_CL_CELL_BUFLEN     513
#define LPI_CL_STRING_BUFLEN   170
#define LPI_CL_FMTVAL_BUFLEN   513
#define LPI_CL_FMTROW_BUFLEN   513
#endif
/* 1-2-3 display window (primary/secondary) selectors */
#if !defined(WINDOW_1)
#define WINDOW_1        1
#endif
#if !defined(WINDOW_2)
#define WINDOW_2        2
#endif
#define LPI_CL_DEFAULT_PLACES   (lulong)2
#if defined(NOGLOBALDATA)
#define LPI_CL_GLOBAL_REF  LPI_CALL_DATA->cl_global
#define LPI_CL_TABLE_REF   LPI_CALL_DATA->cl_table
#else
#define LPI_CL_GLOBAL_REF  lts_cl_global
#define LPI_CL_TABLE_REF   lts_cl_table
#endif
#define LpiClConstructCurrent(xADTdata)                         \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_current)           \
        (LPI_CL_GLOBAL_REF,xADTdata)
#define LpiClConstructString(xADTdata, arg1)                    \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_string)            \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClConstructXY(xADTdata, arg1, arg2)                  \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_xy)                \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClConstructZXY(xADTdata, arg1, arg2, arg3)           \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_zxy)               \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiClConstructWZXY(xADTdata, arg1, arg2, arg3, arg4)    \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_wzxy)              \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4)
#define LpiClConstructContext(xADTdata, arg1)                   \
        (*LPI_CL_TABLE_REF->lpi_cl_construct_context)           \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClDestroy(xADTdata)                                  \
        (*LPI_CL_TABLE_REF->lpi_cl_destroy)                     \
        (LPI_CL_GLOBAL_REF,xADTdata)
#define LpiClString(xADTdata, arg1)                             \
        (*LPI_CL_TABLE_REF->lpi_cl_string)                      \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetIsValid(xADTdata, arg1)                         \
        (*LPI_CL_TABLE_REF->lpi_cl_get_isvalid)                 \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetCellType(xADTdata, arg1)                        \
        (*LPI_CL_TABLE_REF->lpi_cl_get_celltype)                \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetDataType(xADTdata, arg1)                        \
        (*LPI_CL_TABLE_REF->lpi_cl_get_datatype)                \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetCoords(xADTdata, arg1, arg2, arg3)              \
        (*LPI_CL_TABLE_REF->lpi_cl_get_coords)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiClGetColumn(xADTdata, arg1)                          \
        (*LPI_CL_TABLE_REF->lpi_cl_get_column)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetColumn(xADTdata, arg1)                          \
        (*LPI_CL_TABLE_REF->lpi_cl_set_column)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetRow(xADTdata, arg1)                             \
        (*LPI_CL_TABLE_REF->lpi_cl_get_row)                     \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetRow(xADTdata, arg1)                             \
        (*LPI_CL_TABLE_REF->lpi_cl_set_row)                     \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetSheet(xADTdata, arg1)                           \
        (*LPI_CL_TABLE_REF->lpi_cl_get_sheet)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetSheet(xADTdata, arg1)                           \
        (*LPI_CL_TABLE_REF->lpi_cl_set_sheet)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetWorkFileName(xADTdata, arg1)                    \
        (*LPI_CL_TABLE_REF->lpi_cl_get_wfile)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetWorkFileName(xADTdata, arg1)                    \
        (*LPI_CL_TABLE_REF->lpi_cl_set_wfile)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClNextSheet(xADTdata)                                \
        (*LPI_CL_TABLE_REF->lpi_cl_next_sheet)                  \
        (LPI_CL_GLOBAL_REF,xADTdata)
#define LpiClPrevSheet(xADTdata)                                \
        (*LPI_CL_TABLE_REF->lpi_cl_prev_sheet)                  \
        (LPI_CL_GLOBAL_REF,xADTdata)
#define LpiClGetWidth(xADTdata, arg1)                           \
        (*LPI_CL_TABLE_REF->lpi_cl_get_width)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,WINDOW_1)
#define LpiClGetWidthWin(xADTdata, arg1, arg2)                  \
        (*LPI_CL_TABLE_REF->lpi_cl_get_width)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClSetWidth(xADTdata, arg1)                           \
        (*LPI_CL_TABLE_REF->lpi_cl_set_width)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,WINDOW_1)
#define LpiClSetWidthWin(xADTdata, arg1, arg2)                  \
        (*LPI_CL_TABLE_REF->lpi_cl_set_width)                   \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClWidthReset(xADTdata)                               \
        (*LPI_CL_TABLE_REF->lpi_cl_reset_width)                 \
        (LPI_CL_GLOBAL_REF,xADTdata,WINDOW_1)
#define LpiClWidthResetWin(xADTdata, arg1)                      \
        (*LPI_CL_TABLE_REF->lpi_cl_reset_width)                 \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetFormat(xADTdata, arg1)                          \
        (*LPI_CL_TABLE_REF->lpi_cl_get_format)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,LNULL)
#define LpiClGetFormatPlaces(xADTdata, arg1, arg2)              \
        (*LPI_CL_TABLE_REF->lpi_cl_get_format)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClSetFormat(xADTdata, arg1, arg2)                    \
        (*LPI_CL_TABLE_REF->lpi_cl_set_format)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,LPI_CL_DEFAULT_PLACES,arg2)
#define LpiClSetFormatPlaces(xADTdata, arg1, arg2, arg3)        \
        (*LPI_CL_TABLE_REF->lpi_cl_set_format)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiClGetLabelPrefix(xADTdata, arg1)                     \
        (*LPI_CL_TABLE_REF->lpi_cl_get_label_prefix)            \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetLabelPrefix(xADTdata, arg1)                     \
        (*LPI_CL_TABLE_REF->lpi_cl_set_label_prefix)            \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetProtection(xADTdata, arg1)                      \
        (*LPI_CL_TABLE_REF->lpi_cl_get_protection)              \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetProtection(xADTdata, arg1, arg2)                \
        (*LPI_CL_TABLE_REF->lpi_cl_set_protection)              \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClGetParentheses(xADTdata, arg1)                     \
        (*LPI_CL_TABLE_REF->lpi_cl_get_parentheses)             \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetParentheses(xADTdata, arg1, arg2)               \
        (*LPI_CL_TABLE_REF->lpi_cl_set_parentheses)             \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClGetColorNegative(xADTdata, arg1)                   \
        (*LPI_CL_TABLE_REF->lpi_cl_get_color_neg)               \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetColorNegative(xADTdata, arg1, arg2)             \
        (*LPI_CL_TABLE_REF->lpi_cl_set_color_neg)               \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClGetHighlight(xADTdata, arg1)                       \
        (*LPI_CL_TABLE_REF->lpi_cl_get_highlight)               \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetHighlight(xADTdata, arg1, arg2)                 \
        (*LPI_CL_TABLE_REF->lpi_cl_set_highlight)               \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClGetValueFloat(xADTdata, arg1)                      \
        (*LPI_CL_TABLE_REF->lpi_cl_get_value_float)             \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetValueFloat(xADTdata, arg1)                      \
        (*LPI_CL_TABLE_REF->lpi_cl_set_value_float)             \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetValueString(xADTdata, arg1)                     \
        (*LPI_CL_TABLE_REF->lpi_cl_get_value_string)            \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetValueString(xADTdata, arg1)                     \
        (*LPI_CL_TABLE_REF->lpi_cl_set_value_string)            \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClGetContents(xADTdata, arg1)                        \
        (*LPI_CL_TABLE_REF->lpi_cl_get_contents)                \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClSetContents(xADTdata, arg1, arg2)                  \
        (*LPI_CL_TABLE_REF->lpi_cl_set_contents)                \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiClCopy(xADTdata1, xADTdata2, arg1)                   \
        (*LPI_CL_TABLE_REF->lpi_cl_copy)                        \
        (LPI_CL_GLOBAL_REF,xADTdata1,xADTdata2,arg1)
#define LpiClMove(xADTdata1, xADTdata2, arg1)                   \
        (*LPI_CL_TABLE_REF->lpi_cl_move)                        \
        (LPI_CL_GLOBAL_REF,xADTdata1,xADTdata2,arg1)
#define LpiClErase(xADTdata, arg1)                              \
        (*LPI_CL_TABLE_REF->lpi_cl_erase)                       \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1)
#define LpiClFormatRow(xADTdata, arg1, arg2)                    \
        (*LPI_CL_TABLE_REF->lpi_cl_format_row)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1, arg2, WINDOW_1)
#define LpiClFormatRowWin(xADTdata, arg1, arg2, arg3)           \
        (*LPI_CL_TABLE_REF->lpi_cl_format_row)                  \
        (LPI_CL_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiClFormatValueInt(arg1, arg2, arg3, arg4)             \
        (LPI_CL_TABLE_REF->lpi_cl_format_val_int)               \
        (LPI_CL_GLOBAL_REF,arg1,arg2,arg3,arg4,LPI_CL_DEFAULT_PLACES)
#define LpiClFormatValueIntPlaces(arg1, arg2, arg3, arg4, arg5) \
        (LPI_CL_TABLE_REF->lpi_cl_format_val_int)               \
        (LPI_CL_GLOBAL_REF,arg1,arg2,arg3,arg4,arg5)
#define LpiClFormatValueFloat(arg1, arg2, arg3, arg4)           \
        (LPI_CL_TABLE_REF->lpi_cl_format_val_float)             \
        (LPI_CL_GLOBAL_REF,arg1,arg2,arg3,arg4,LPI_CL_DEFAULT_PLACES)
#define LpiClFormatValueFloatPlaces(arg1, arg2, arg3, arg4, arg5) \
        (LPI_CL_TABLE_REF->lpi_cl_format_val_float)             \
        (LPI_CL_GLOBAL_REF,arg1,arg2,arg3,arg4,arg5)
#define LpiClFormatValueString(arg1, arg2, arg3, arg4)          \
        (*LPI_CL_TABLE_REF->lpi_cl_format_val_str)              \
        (LPI_CL_GLOBAL_REF,arg1,arg2,arg3,arg4)
#endif  /* defined(LPIXPORT_H) */
#endif  /* !defined(CELL_PLX) */
